#ifndef FFS_H
#define	FFS_H

//
//pozriet do  device object sector size
#include "inc/ver.h"
#include "ntddk.h"
#include "inc/mojetypy.h"
#include "inc/dinode.h"
#include "inc/ntifs.h"
#include "inc/hlavicky.h"
#include "inc/disklabel.h"
#include "inc/fs.h"
#include "inc/types.h"
#include "inc/dirent.h"
#include "ntdddisk.h"



extern T_MAIN_DATA   GlobalData;
//zauvaova preo tu mus by to extern
T_MAIN_DATA GlobalData;
#define DEVICE_NAME     L"\\Ffs"
#define DRIVER_NAME       "Ffs"
#define DOS_DEVICE_NAME L"\\DosDevices\\Ffs"
#define FS_NAME L"FFS"
#define MIN_DIRENT  12
#define MAX_NAME_LENGTH  255
#define SEARCH_MAX    256
#define TOKEN  '\\'
#define W_TOKEN L'\\'
#define END '\0'
#define TAG '1sff'
#define ROOT_INODE 2
#define	DT_DIR		 4
//max poet sektorovo ktore sa bude hladat disklabel
// pocet sektorov od zaciatku particie kde sa nachadza superblok
//#define SEARCH_BUF  8192
//vhodn nsobok neviem oho
// Tak vek buffer na stacku to neznieslo
#define SEARCH_BUF  2048
// trepa popremla nad dyn. alokciou bo 2048 je dos mlo
// mus to by vasie ako 8+maxname length
#define IOCTL_PREPARE_TO_UNLOAD \
    CTL_CODE(FILE_DEVICE_UNKNOWN, 2048, METHOD_NEITHER, FILE_WRITE_ACCESS)

#undef FLAG_ON

#undef SET_FLAG

#undef CLEAR_FLAG

#define FLAG_ON(x,f)     ((BOOLEAN)((((x) & (f)) != 0)))

#define SET_FLAG(x,f)    ((x) |= (f))

#define CLEAR_FLAG(x,f)  ((x) &= ~(f))

#define SECTOR_SIZE                     (512)
//dfame
#define  DEV_BSIZE   SECTOR_SIZE

// len negativne vystupy preffc chrecks
#define WPP_CONTROL_GUIDS \
    WPP_DEFINE_CONTROL_GUID(FfsGuid,(61644C5B,DC76,4ea5,BBA8,328058BFE44C),\
        WPP_DEFINE_BIT(FFS_INIT_DONE)  \
        WPP_DEFINE_BIT(FFS_EXCEPTION)  \
        WPP_DEFINE_BIT(FFS_CHECKS)\
        WPP_DEFINE_BIT(FFS_FSCONTROL)  \
		    WPP_DEFINE_BIT(FFS_READ)  \
	      WPP_DEFINE_BIT(FFS_CREATE_CLOSE)  \
        WPP_DEFINE_BIT(FFS_MOUNT_UMOUNT)  \
        WPP_DEFINE_BIT(FFS_IO)  \
        WPP_DEFINE_BIT(FFS_LOCKING)  \
        WPP_DEFINE_BIT(FFS_VOLUME)  \
        WPP_DEFINE_BIT(FFS_VCB)  \
        WPP_DEFINE_BIT(FFS_FCB)  \
        WPP_DEFINE_BIT(FFS_CCB)  \
        WPP_DEFINE_BIT(FFS_QDIR)  \
        WPP_DEFINE_BIT(FFS_INODE)  \
        WPP_DEFINE_BIT(NameOfTraceFlag31) )







#endif /* FFS_H */

