#include "inc/ffs.h"
#include "except.tmh"

/*************************************************************************************
*
* Tto funkcia uruje o sa s danou vnimkou urob, i sa spracuje, pod alej,
* alebo sa bude pokraova vo vykonvan programu.
*
* Tento filter zoerie vetko.
* Filter sa d poui aj na zskanie kdu vnimky a to potom poui vo finally.
*
**************************************************************************************/
long FilterVynimky (NTSTATUS	ExceptionCode)
{
	long							What = EXCEPTION_EXECUTE_HANDLER;
	return(What);
	// Mono potom budem rozliova, ktor vnimky sa bud spracova a ktor nie.
} /* FilterVynimiek */

/************************************************************************************
*
* Jedin obsluha vnimky je vpis do logu a ukonenie danho irp. Ak by ma
* nieo napadlo tak to sem pridm.
*
*************************************************************************************/
NTSTATUS ObsluhaVynimky (PIRP Irp, NTSTATUS ExceptionCode)
{
	if (!(Irp==NULL))
	{
		Irp->IoStatus.Status = ExceptionCode;
		Irp->IoStatus.Information = 0;
		IoCompleteRequest(Irp, IO_NO_INCREMENT);
	}
	// Ak nie je vnimka tak poiadavku ukon sama procedra - vinou finally.
	// Problm je o ak nastane vnimka a dan irp sa nem ukoni.
	// Zatia v programe ni tak nie je.

        DoTraceMessage(FFS_EXCEPTION,"Catching  exception  number %u",ExceptionCode);
        return(ExceptionCode);
	// Vymyslel to pekne. Bu bude vsledok z volanej procedry alebo z tejto
	// obsluhy vnimky.
} /* ObsluhaVynimky */


